/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8175_CMPFUNO_EMITENTE.sql

Descrio:
Retorna o emitente da AF (destinatrio da NF).

Criao:
09/01/2004 Joo Fernando dos Reis Corra
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'EMITENTE' AND
                 TYPE = 'FN' 		       AND
	              U.UID = O.UID            AND
	              U.NAME = USER)
DROP FUNCTION EMITENTE
GO

CREATE FUNCTION EMITENTE(
   @P_CDFILIAL     VARCHAR(4),
   @P_CDPRODUTO    VARCHAR(10),
   @P_CDFORNECED    VARCHAR(21)) RETURNS VARCHAR(4)
AS
BEGIN
   DECLARE @V_IDEMITAFDES VARCHAR(1);
   DECLARE @V_CDEMPRESA   VARCHAR(2);
   DECLARE @V_CDARVPROD   VARCHAR(20);

   SELECT
      @V_CDARVPROD = CDARVPROD
   FROM
      PRODUTO
   WHERE
      (CDPRODUTO = @P_CDPRODUTO);

   SELECT
      @V_IDEMITAFDES = MAX(EMITAFFORN.IDEMITAFFORN),
      @V_CDEMPRESA   = MAX(EMITAFFORN.CDEMPRESA)
   FROM
      EMITAFFORN,
      PRODUTO
   WHERE
      (EMITAFFORN.CDFILIAL   = @P_CDFILIAL)          AND
      (EMITAFFORN.CDFORNECED = @P_CDFORNECED)        AND
      (PRODUTO.CDPRODUTO     = EMITAFFORN.CDPRODUTO) AND
      (PRODUTO.CDARVPROD     = (SELECT
                                   MAX(P.CDARVPROD)
                                FROM
                                   EMITAFFORN E,
                                   PRODUTO P
                                WHERE
                                   (E.CDFILIAL   = @P_CDFILIAL)   AND
                                   (E.CDFORNECED = @P_CDFORNECED) AND
                                   (P.CDPRODUTO  = E.CDPRODUTO)  AND
                                   (CHARINDEX(P.CDARVPROD, @V_CDARVPROD) = 1)));

   IF @V_IDEMITAFDES IS NULL BEGIN
      SELECT
         @V_IDEMITAFDES = MAX(EMITENTEAF.IDEMITAFDES),
         @V_CDEMPRESA   = MAX(EMITENTEAF.CDEMPRESA)
      FROM
         EMITENTEAF,
         PRODUTO
      WHERE
         (EMITENTEAF.CDFILIAL = @P_CDFILIAL)  AND
         (PRODUTO.CDPRODUTO   = EMITENTEAF.CDPRODUTO) AND
         (PRODUTO.CDARVPROD   = (SELECT
                                    MAX(P.CDARVPROD)
                                 FROM
                                    EMITENTEAF E,
                                    PRODUTO P
                                 WHERE
                                    (E.CDFILIAL  = @P_CDFILIAL)  AND
                                    (P.CDPRODUTO = E.CDPRODUTO) AND
                                    (CHARINDEX(P.CDARVPROD, @V_CDARVPROD) = 1)));
   END;

   IF @V_IDEMITAFDES IS NULL BEGIN
      SELECT
         @V_IDEMITAFDES = MAX(PARCMPSUP.IDTIPEMITGER),
         @V_CDEMPRESA   = MAX(PARCMPSUP.CDEMPRESA)
      FROM
         PARCMPSUP
      WHERE
         (PARCMPSUP.CDFILIAL = @P_CDFILIAL);
   END;

   IF (@V_IDEMITAFDES = '1') OR (@V_IDEMITAFDES = '3') BEGIN
      SELECT
         @V_CDEMPRESA = MAX(FILIAL.CDEMPRESA)
      FROM
         FILIAL
      WHERE
         (CDFILIAL = @P_CDFILIAL);
   END;

   RETURN (@V_IDEMITAFDES + '_' + @V_CDEMPRESA);
END
GO